<template>
  <b-modal
    :title="editMode ? 'Edit User' : 'New User'"
    small
    :visible.sync="visible"
    @close="$emit('close')"
  >
    <div class="row">
      <div class="col-12">
        <b-form-item
          :label="$t('vuelidate.fields.name')"
          :error="$validationMessage('name', $v.user.fullName)"
        >
          <b-input v-model="user.fullName"></b-input>
        </b-form-item>
      </div>
      <div class="col-12">
        <b-form-item
          :label="$t('vuelidate.fields.email')"
          :error="
            $validationMessage('email', $v.user.email) ||
            (emailExisted &&
              !editMode &&
              $t('vuelidate.messages.existed', [
                $t('vuelidate.fields.email'),
              ])) ||
            ''
          "
        >
          <b-input v-model="user.email"></b-input>
        </b-form-item>
      </div>
      <div class="col-12">
        <b-form-item
          :label="$t('vuelidate.fields.contactNumber')"
          :error="$validationMessage('contactNumber', $v.user.phoneNumber)"
        >
          <b-phone-input
            v-model="phoneNumber"
            @change="(value) => (user.phoneNumber = value)"
          ></b-phone-input>
        </b-form-item>
      </div>
    </div>

    <!-- Footer -->
    <div slot="footer" class="d-flex content-end">
      <b-button @click.prevent="$emit('close')">Cancel</b-button>
      <b-button
        native-type="submit"
        primary
        class="ml-4x"
        @click.prevent="handleSubmit"
        >{{ editMode ? 'Save changes' : 'Create' }}</b-button
      >
    </div>
  </b-modal>
</template>

<script lang="ts">
import { cloneDeep } from 'lodash'
import Vue from 'vue'
import { required, email, minLength, maxLength } from 'vuelidate/lib/validators'
import { UserObject } from '~/models/law'

export default Vue.extend({
  name: 'AddEditUserModal',
  props: {
    entity: {
      type: Object,
      default() {
        return {}
      },
    },
  },
  data() {
    return {
      visible: false,
      loading: false,
      editMode: false,
      emailExisted: false,

      user: {} as UserObject,
      phoneNumber: '',

      showOptionInput: false,
      options: [] as number[],
    }
  },
  validations: {
    user: {
      fullName: { required },
      email: { required, email },
      phoneNumber: {
        minLength: minLength(9),
        maxLength: maxLength(15),
      },
    },
  },
  created() {
    if (this.entity) {
      this.editMode = true
      this.user = cloneDeep(this.entity)
      this.phoneNumber = this.user.phoneNumber || ''
    }

    setTimeout(() => (this.visible = true), 1)
  },
  methods: {
    async handleSubmit() {
      this.$v.$touch()
      if (!this.$v.$invalid) {
        try {
          !this.editMode &&
            (this.emailExisted = await this.$services.law.checkExistsEmail(
              `${this.user.email}`
            ))
          if (this.emailExisted) return false

          if (this.entity?.id) {
            const user = cloneDeep(this.user)
            user.id = this.entity.id

            const rs = await this.$store.dispatch('law/updateUser', user)
            if (rs) this.$message('User updated successfully')
            else this.$message.error('User updated fail')
          } else {
            const rs = await this.$store.dispatch('law/createUser', this.user)
            if (rs) this.$message('User created successfully')
            else this.$message.error('User created fail')
          }

          this.$emit('submit', this.user)
        } catch (error) {
          this.$message.error(`Something went wrong!`)
        }
      }
    },
  },
})
</script>
